package sahoo;

import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import javax.persistence.PersistenceContext;
import javax.persistence.EntityManager;

public class Servlet extends HttpServlet {

    @PersistenceContext EntityManager em;
    @javax.annotation.Resource javax.transaction.UserTransaction utx;

    public void  init( ServletConfig config) throws ServletException {
        super.init(config);
        System.out.println("In sahoo::servlet... init()");
    }
    
    public void service ( HttpServletRequest req , HttpServletResponse resp ) throws ServletException, IOException {
                 
        resp.setContentType("text/html");
        PrintWriter out = resp.getWriter();
        
        try {
            out.println("<HTML> <HEAD> <TITLE> Servlet Output </TITLE> </HEAD> <BODY BGCOLOR=white>");
            out.println("<CENTER> <FONT size=+1 COLOR=blue> FOO </FONT> </CENTER> <p> " );
            out.println("<FONT size=+1 color=red> Context Path :  </FONT> " + req.getContextPath() + "<br>" ); 
            out.println("<FONT size=+1 color=red> Servlet Path :  </FONT> " + req.getServletPath() + "<br>" ); 
	    out.println("<FONT size=+1 color=red> Path Info :  </FONT> " + req.getPathInfo() + "<br>" ); 
            String name = req.getParameter("name");
            if(name==null || name.length()==0){
              throw new ServletException("request parameret by name [name] is empty");
            }
            out.println("<FONT size=+1 color=red> request.getParameter(\"name\") :  </FONT> " + name + "<br>" ); 
            out.println("Beginning a tx" + "<br>");
            utx.begin();
            out.println("Creating a new Person(" + name + ")" + "<br>" ); 
            Person p = new Person(name);
            em.persist(p);
            out.println("Persisted" +  "<br>" ); 
            out.println("Commiting the tx" + "<br>");
            utx.commit();
            out.println("Calling em.find(" + name + ")" + "<br>" ); 
            p = em.find(Person.class, name);
            out.println("Found " + p + "<br>" ); 
            out.println("</BODY> </HTML> ");
            
        }catch (Exception ex) {
            ex.printStackTrace();
            System.out.println("sahoo servlet test failed");
            throw new ServletException(ex);
        } 
    }

    
    
    public void  destroy() {
        System.out.println("in sahoo::servlet destroy");
    }
    
}
